/*
*  POPProxyDlgs.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Global.h"
#include "POPProxyDlgs.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TProxyDlg *ProxyDlg;
//---------------------------------------------------------------------------

bool __fastcall OpenPOPProxyDlg(TForm *Owner, TStrings *Params)
{
   bool ok = false;
   ProxyDlg = new TProxyDlg(Owner);
   ProxyDlg->Server->Text = Params->Values["hostname"];
   ProxyDlg->Port->Text   = Params->Values["hostport"];
   ProxyDlg->SocksBox->ItemIndex = ProxyDlg->SocksBox->Items->IndexOf(Params->Values["socksver"]);
   if (ProxyDlg->SocksBox->ItemIndex < 0)
      ProxyDlg->SocksBox->ItemIndex = 0;
   ProxyDlg->Password->Text = Params->Values["password"];
   ProxyDlg->UserID->Text = Params->Values["userid"];

   ProxyDlg->Server->Modified = false;
   ProxyDlg->Port->Modified = false;
   ProxyDlg->UserID->Modified = false;
   ProxyDlg->Password->Modified = false;
   ProxyDlg->SocksBoxOrg = ProxyDlg->SocksBox->Text;

   ProxyDlg->ShowModal();
   if (ProxyDlg->ModalResult == mrOk && ProxyDlg->Modified())
   {
      Params->Values["hostname"] = ProxyDlg->Server->Text;
      Params->Values["hostport"] = ProxyDlg->Port->Text;
      Params->Values["socksver"] = ProxyDlg->SocksBox->Text;
      Params->Values["password"] = ProxyDlg->Password->Text;
      Params->Values["userid"]   = ProxyDlg->UserID->Text;
      ok = true;
   }

   delete ProxyDlg;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall TProxyDlg::TProxyDlg(TComponent* Owner)
        : TForm(Owner)
{
   CenterDialog(this, Owner);
}
//---------------------------------------------------------------------------

bool __fastcall TProxyDlg::Modified()
{
   bool mod =
     Server->Modified   ||
     Port->Modified     ||
     UserID->Modified   ||
     Password->Modified ||
     SocksBox->Text != SocksBoxOrg;
   return mod;
}
//---------------------------------------------------------------------------
